/* ----------------------------------------------------------------------------
	AXP-PI02 TvvO
	MS-DOS C

	AXP-PI02p֐̃Tv

	Copyright (C) 1997 ADTEK SYSTEM SCIENCE Co.,Ltd.
---------------------------------------------------------------------------- */


#include	<stdio.h>
//#include	<stdlib.h>
#include	<dos.h>
#include	<conio.h>
//#include	<fcntl.h>
//#include	<sys\stat.h>

#include	"pi02.h"


/*
 [O]
	_ioctrl		I/O Rg[
 [`]
	_ioctrl(int hd,int rw,int size,void far * ptr);
 []
	hd		hCõt@Cnh
	rw		0:[h
				obt@ɃhCõf[^ǂݏoB
			!0:Cg
				obt@̃f[^hCoɏށB
	size		[h^CgTCY
	ptr		obt@ւ̃|C^
			 far|C^łȂ΂ȂȂB
 [@\]
	IORg[[h^CgsB
*/
int	_ioctrl( int hd, int rw, int size, void far *ptr ){
	union REGS	inreg, outreg ;		/* intXXXX		*/
	struct SREGS	segreg ;		/* segments		*/

	/* register */
	inreg.h.ah=0x44 ;			/* IOCTRL		*/
	if( rw == 0 ){
		inreg.h.al=0x02 ;		/* IOCTRL READ		*/
	}
	else {
		inreg.h.al=0x03 ;		/* IOCTRL WRITE		*/
	}
	inreg.x.bx = hd ;			/* card handle		*/
	inreg.x.cx = size ;			/* command length	*/
	inreg.x.dx = FP_OFF( ptr ) ;		/* offset of para_tbl 	*/
	segreg.ds = FP_SEG( ptr ) ;		/* segment of para_tbl	*/
	intdosx( &inreg, &outreg, &segreg ) ;
	if( outreg.x.cflag ){
		return	-1 ;
	}
	return	0 ;
}


/*
 [O]
	set_mode	[h̐ݒ
 [`]
	set_mode(int mode,unsigned short io_addr,unsigned short dir_addr);
 []
	mode		ݒ肷郂[hԍ
	io_addr		擪|[gAhX
	dir_addr	fBNVAhX
 [Ԓl]
	0		
	-1		G[
 [@\]
	modeŎw肳ꂽo̓[hɁAAXP-PI02ݒ肷B
	戵@"t^A. 샂[hꗗ"@QƂ̂ƁB
*/
int	set_mode(int mode,unsigned short io_addr,unsigned short dir_addr){
	unsigned short	cmd_1,cmd_2,cmd_3;

	/* ԍ */
	switch(mode){
		case  0: cmd_1 = 0x9B;cmd_2 = 0x15;cmd_3 = 0x00;break;
		case  1: cmd_1 = 0x92;cmd_2 = 0x35;cmd_3 = 0x20;break;
		case  2: cmd_1 = 0x99;cmd_2 = 0x19;cmd_3 = 0x08;break;
		case  3: cmd_1 = 0x90;cmd_2 = 0x39;cmd_3 = 0x28;break;
		case  4: cmd_1 = 0x8B;cmd_2 = 0x17;cmd_3 = 0x02;break;
		case  5: cmd_1 = 0x82;cmd_2 = 0x37;cmd_3 = 0x22;break;
		case  6: cmd_1 = 0x89;cmd_2 = 0x1F;cmd_3 = 0x0A;break;
		case  7: cmd_1 = 0x80;cmd_2 = 0x3F;cmd_3 = 0x2A;break;

		case  8: cmd_1 = 0xBB;cmd_2 = 0x15;cmd_3 = 0x50;break;
		case  9: cmd_1 = 0xB9;cmd_2 = 0x19;cmd_3 = 0x58;break;
		case 10: cmd_1 = 0xAB;cmd_2 = 0x17;cmd_3 = 0x52;break;
		case 11: cmd_1 = 0xA9;cmd_2 = 0x1F;cmd_3 = 0x5A;break;

		case 12: cmd_1 = 0x9F;cmd_2 = 0x15;cmd_3 = 0x50;break;
		case 13: cmd_1 = 0x9D;cmd_2 = 0x19;cmd_3 = 0x58;break;
		case 14: cmd_1 = 0x8F;cmd_2 = 0x17;cmd_3 = 0x52;break;
		case 15: cmd_1 = 0x8D;cmd_2 = 0x1F;cmd_3 = 0x5A;break;

		case 16: cmd_1 = 0xBF;cmd_2 = 0x15;cmd_3 = 0x50;break;
		case 17: cmd_1 = 0xBD;cmd_2 = 0x19;cmd_3 = 0x58;break;
		case 18: cmd_1 = 0xAF;cmd_2 = 0x17;cmd_3 = 0x52;break;
		case 19: cmd_1 = 0xAD;cmd_2 = 0x1F;cmd_3 = 0x5A;break;

		default:
			/* Y郂[hȂ */
			return	-1;
	}

	/* fBNVAhXɁA0x15 */
	outp(dir_addr,0x15);

	/* IOAhX+3ɁAR}hP */
	outp(io_addr+3,cmd_1);

	/* fBNVAhXɁAR}hQER */
	outp(dir_addr,cmd_2);
	outp(dir_addr,cmd_3);

	return	0;
}


/*
 [O]
	get_PI02_inf	PI02̏擾
 [`]
	void	get_PI02_inf(int hd,PI02_INF * inf);
 []
	hd		PI02hConh(t@Cnh)
	inf		PI02\̂ւ̃|C^
 [Ԓl]
	0		
	-1		G[
 [@\]
*/
void	get_PI02_inf(int hd,PI02_INF * inf){
	short 	ioctrl_cmd;

	/***
		IORg[ɂ
		IORg[CggpāAPhCoɏށB
		ɁAIORg[[hŁAhCoǂݏoƁA
		PI02IOAhX̏񂪎擾łB

		PȊÕR}hɂẮAJB
		IORg[ɂẮAMS-DOS̉QƂ̂ƁB
	***/

	ioctrl_cmd = 1; /* 擾R}h@@P */
	/* IORg[Cg() */
	_ioctrl(hd,1,sizeof(short),(void far *)&ioctrl_cmd);
	/* IORg[[hŁAobt@(buf)ɓǂݏo */
	_ioctrl(hd,0,sizeof(PI02_INF),(void far *)inf);
}

