/* ----------------------------------------------------------------------------
	AXP-PI02 TvvO
	MS-DOS C

	AXP-PI02ɊmۂꂽAIOAhXAIORg[ɂĎ擾A
	fBNV[hݒAIOsB

	Copyright (C) 1997 ADTEK SYSTEM SCIENCE Co.,Ltd.
---------------------------------------------------------------------------- */

#include	<stdio.h>
#include	<stdlib.h>
#include	<dos.h>
#include	<conio.h>
#include	<fcntl.h>
#include	<sys\stat.h>

#include	"pi02.h"


void	disp_inf(PI02_INF *);
void	in_port(unsigned short,unsigned short);
void	out_port(unsigned short,unsigned short);

void	main(void){
	int		hd,end_flg,cmd;
	unsigned short	io_addr,dir_addr;
	char		buf[20];
	PI02_INF	inf;

	/* foCXI[v */
	hd = open("AXP$PI02",O_RDONLY) ;
	if( hd < 0 ){
		printf( "DEVICE (AXP$PI02) OPEN ERROR!\n") ;
		exit( 1 ) ;
	}

	/* AXP-PI02 IOAhX擾 */
	get_PI02_inf(hd,&inf);
	if(inf.log_socket == 0xFFFF){
		/* J[h */
		printf("NO CARD!\n");
		goto	_EXT;
	}

	/* AhX擾 */
	io_addr  = inf.io_addr[0];	/* 擪IOAhX		*/
	dir_addr = inf.io_addr[1];	/* fBNVAhX	*/

	printf("### AXP-PI02 TvvO ###\n");

	end_flg = 1;
	while(end_flg){
		printf("\n1:AXP-PI02\  2:|[g  3:|[go  0:I\n");
		printf("I --->");
		gets(buf);
		cmd = atoi(buf);
		switch(cmd){
			case 1:	/* \ */
				disp_inf(&inf);
				break;
			case 2: /* |[g */
				in_port(io_addr,dir_addr);
				break;
			case 3: /* |[go */
				out_port(io_addr,dir_addr);
				break;
			case 0:	/* I */
				printf("I\n");
				end_flg = 0;
				break;
			default:
				break;
		}
	}
_EXT:;
	/* I */
	close( hd ) ;
	exit( 0 ) ;
}


/* PI02̏\ */
void	disp_inf(PI02_INF * pinf)
{
	/* AXP-PI02̏\ */
	printf("+--- AXP-PI02 -----------------+\n");
	printf("    I/O ڽ      : %04X H\n",pinf->io_addr[0]);
	printf("               : %d ޲\n",pinf->io_len[0]);
	printf("    ިڸ ڽ : %04X H\n",pinf->io_addr[1]);
	printf("               : %d ޲\n",pinf->io_len[1]);
	if(pinf->irq < 16){
		printf("    IRQԍ        : %d\n",(int)pinf->irq);
	}else{
		printf("    IRQԍ        : gp\n");
	}
	printf("+------------------------------+\n");
}


/* |[g */
void	in_port(unsigned short io_addr,unsigned short dir_addr)
{
	unsigned short	data_a,data_b,data_c;

	/* [hݒ */
	/* 戵@"t^A. 샂[hꗗ"A
	@@pi02.ct@Cset_mode֐Q	*/
	set_mode(0,io_addr,dir_addr);	/* |[gA,B,C ͂ɐݒ	*/

	/* ӁI@@ɂẮAɃfB[Kvȏꍇ */
	/* delay(1);*/

	/*  */
	data_a = inp(io_addr);		/* |[g` */
	data_b = inp(io_addr+1);	/* |[ga */
	data_c = inp(io_addr+2);	/* |[gb */
	printf("|[g`:[%02X] |[ga:[%02X] |[gb:[%02X]\n",
		data_a,data_b,data_c);
}


/* |[go */
void	out_port(unsigned short io_addr,unsigned short dir_addr)
{
	unsigned short	data_a,data_b,data_c;
	char		buf[20],*stop;

	/* e|[gɏo͂l(16i) */
	printf("|[g` --->"); gets(buf); data_a = strtoul(buf,&stop,16);
	printf("|[ga --->"); gets(buf); data_b = strtoul(buf,&stop,16);
	printf("|[gb --->"); gets(buf); data_c = strtoul(buf,&stop,16);

	/* [hݒ */
	set_mode(7,io_addr,dir_addr);	/* |[gA,B,C o͂ɐݒ */

	/* o */
	outp(io_addr,data_a);		/* |[g` */
	outp(io_addr+1,data_b);		/* |[ga */
	outp(io_addr+2,data_c);		/* |[gb */
}
